Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloader.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -46,5 +46,5 @@
 
       task.ContinueWith((x) => OnTaskFinished(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnRanToCompletion);
-      task.ContinueWith((x) => OnTaskFailed(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
+      task.ContinueWith((x) => OnTaskFailed(x), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
     }
 
@@ -55,5 +55,5 @@
 
       task.ContinueWith((x) => OnTaskFinished(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnRanToCompletion);
-      task.ContinueWith((x) => OnTaskFailed(x, onFinishedAction), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
+      task.ContinueWith((x) => OnTaskFailed(x), TaskContinuationOptions.ExecuteSynchronously | TaskContinuationOptions.OnlyOnFaulted);
     }
 
@@ -61,8 +61,7 @@
       onFinishedAction(task.Result.Item1, task.Result.Item2);
     }
-    private void OnTaskFailed(Task<Tuple<Task, T>> task, Action<Task, T> onFinishedAction) {
+    private void OnTaskFailed(Task<Tuple<Task, T>> task) {
       task.Exception.Flatten().Handle((e) => { return true; });
       OnExceptionOccured(task.Exception.Flatten());
-      onFinishedAction(task.Result.Item1, null);
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ConcurrentTaskDownloaderException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AddTaskToHiveException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/AnonymousUserException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/HiveException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/OptimizerNotFoundException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ResourceNotFoundException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/ServiceClientFactoryException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Exceptions/TaskResultPollingException.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveAdminClient.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -265,5 +265,5 @@
       try {
         refreshableJob.IsProgressing = true;
-        refreshableJob.Progress = new Progress("Connecting to server...");
+        refreshableJob.Progress.Start("Connecting to server...");
         IEnumerable<string> resourceNames = ToResourceNameList(refreshableJob.Job.ResourceNames);
         var resourceIds = new List<Guid>();
@@ -351,5 +351,5 @@
     /// </summary>
     /// <param name="parentHiveTask">shall be null if its the root task</param>
-    private void UploadTaskWithChildren(Progress progress, HiveTask hiveTask, HiveTask parentHiveTask, IEnumerable<Guid> groups, int[] taskCount, int totalJobCount, Guid configPluginId, Guid jobId, ILog log, bool isPrivileged, CancellationToken cancellationToken) {
+    private void UploadTaskWithChildren(IProgress progress, HiveTask hiveTask, HiveTask parentHiveTask, IEnumerable<Guid> groups, int[] taskCount, int totalJobCount, Guid configPluginId, Guid jobId, ILog log, bool isPrivileged, CancellationToken cancellationToken) {
       taskUploadSemaphore.WaitOne();
       bool semaphoreReleased = false;
@@ -362,5 +362,5 @@
         List<IPluginDescription> plugins;
 
-        if (hiveTask.ItemTask.ComputeInParallel && (hiveTask.ItemTask.Item is Optimization.Experiment || hiveTask.ItemTask.Item is Optimization.BatchRun)) {
+        if (hiveTask.ItemTask.ComputeInParallel) {
           hiveTask.Task.IsParentTask = true;
           hiveTask.Task.FinishWhenChildJobsFinished = true;
@@ -424,5 +424,4 @@
       var hiveExperiment = refreshableJob.Job;
       refreshableJob.IsProgressing = true;
-      refreshableJob.Progress = new Progress();
       TaskDownloader downloader = null;
 
@@ -431,7 +430,6 @@
         IEnumerable<LightweightTask> allTasks;
 
-        refreshableJob.Progress.Status = "Connecting to Server...";
         // fetch all task objects to create the full tree of tree of HiveTask objects
-        refreshableJob.Progress.Status = "Downloading list of tasks...";
+        refreshableJob.Progress.Start("Downloading list of tasks...");
         allTasks = HiveServiceLocator.Instance.CallHiveService(s => s.GetLightweightJobTasksWithoutStateLog(hiveExperiment.Id));
         totalJobCount = allTasks.Count();
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,4 +21,5 @@
 
 using System;
+using System.ServiceModel;
 using HeuristicLab.Clients.Common;
 
@@ -35,4 +36,7 @@
     }
 
+    private HiveServiceLocator() {
+    }
+
     private string username;
     public string Username {
@@ -47,11 +51,11 @@
     }
 
-    private int endpointRetries;
+    public int EndpointRetries { get; private set; }
 
-    private string workingEndpoint;
+    public string WorkingEndpoint { get; private set; }
 
     private HiveServiceClient NewServiceClient() {
-      if (endpointRetries >= Settings.Default.MaxEndpointRetries) {
-        return CreateClient(workingEndpoint);
+      if (EndpointRetries >= Settings.Default.MaxEndpointRetries) {
+        return CreateClient(WorkingEndpoint);
       }
 
@@ -63,14 +67,14 @@
           var cl = CreateClient(endpointConfigurationName);
           cl.Open();
-          workingEndpoint = endpointConfigurationName;
+          WorkingEndpoint = endpointConfigurationName;
           return cl;
         }
-        catch (Exception exc) {
+        catch (EndpointNotFoundException exc) {
           exception = exc;
-          endpointRetries++;
+          EndpointRetries++;
         }
       }
 
-      throw exception;
+      throw exception ?? new Exception("No endpoint for Hive service found.");
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,6 +32,6 @@
     #region Constructors and cloning
     public EngineHiveTask() { }
-    public EngineHiveTask(EngineTask engineJob, IScope parentScopeClone)
-      : base(engineJob) {
+    public EngineHiveTask(EngineTask engineTask, IScope parentScopeClone)
+      : base(engineTask) {
       this.parentScopeClone = parentScopeClone;
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -172,5 +172,7 @@
     protected HiveTask(bool deserializing) { }
 
-    public HiveTask() {
+    public HiveTask()
+      : base() {
+      Name = "Hive Task";
       this.Task = new Task() { CoresNeeded = 1, MemoryNeeded = 128 };
       task.State = TaskState.Offline;
@@ -180,14 +182,14 @@
     }
 
-    public HiveTask(ItemTask itemJob, bool autoCreateChildHiveJobs)
+    public HiveTask(ItemTask itemTask, bool autoCreateChildHiveTasks)
       : this() {
-      this.syncTasksWithOptimizers = autoCreateChildHiveJobs;
-      this.ItemTask = itemJob;
+      this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
+      this.ItemTask = itemTask;
       this.syncTasksWithOptimizers = true;
     }
 
-    public HiveTask(Task job, TaskData taskData, bool autoCreateChildHiveTasks) {
+    public HiveTask(Task task, TaskData taskData, bool autoCreateChildHiveTasks) {
       this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
-      this.Task = job;
+      this.Task = task;
       try {
         this.ItemTask = PersistenceUtil.Deserialize<ItemTask>(taskData.Data);
@@ -543,5 +545,5 @@
     public new T ItemTask {
       get { return (T)base.ItemTask; }
-      internal set { base.ItemTask = value; }
+      set { base.ItemTask = value; }
     }
 
@@ -550,5 +552,5 @@
     [StorableConstructor]
     protected HiveTask(bool deserializing) { }
-    public HiveTask(T itemJob) : base(itemJob, true) { }
+    public HiveTask(T itemTask) : base(itemTask, true) { }
     protected HiveTask(HiveTask<T> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/OptimizerHiveTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -26,4 +26,5 @@
 using HeuristicLab.Collections;
 using HeuristicLab.Common;
+using HeuristicLab.MainForm;
 using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
@@ -31,6 +32,10 @@
 namespace HeuristicLab.Clients.Hive {
   public class OptimizerHiveTask : HiveTask<OptimizerTask> {
+    public Progress Progress { get; private set; }
+
     #region Constructors and Cloning
-    public OptimizerHiveTask() { }
+    public OptimizerHiveTask() {
+      Progress = new Progress();
+    }
     public OptimizerHiveTask(IOptimizer optimizer)
       : this() {
@@ -43,4 +48,5 @@
     protected OptimizerHiveTask(OptimizerHiveTask original, Cloner cloner)
       : base(original, cloner) {
+      Progress = new Progress();
     }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/IHiveServiceLocator.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/JobResultPoller.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.Clients.Hive {
-  [Plugin("HeuristicLab.Clients.Hive", "3.3.7.$WCREV$")]
+  [Plugin("HeuristicLab.Clients.Hive", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Properties/AssemblyInfo.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2014 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.10.$WCREV$")]
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -157,6 +157,6 @@
     }
 
-    private Progress progress;
-    public Progress Progress {
+    private IProgress progress;
+    public IProgress Progress {
       get { return progress; }
       set {
@@ -178,4 +178,5 @@
     #region Constructors and Cloning
     public RefreshableJob() {
+      this.progress = new Progress();
       this.refreshAutomatically = false;
       this.Job = new Job();
@@ -186,4 +187,5 @@
     }
     public RefreshableJob(Job hiveJob) {
+      this.progress = new Progress();
       this.refreshAutomatically = true;
       this.Job = hiveJob;
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ScopeExtensions.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Downtime.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Heartbeat.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItem.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/HiveItemCollection.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/IHiveItem.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Job.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/JobPermission.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/LightweightTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/MessageContainer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/NamedHiveItem.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Plugin.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/PluginData.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Resource.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/ResourcePermission.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Slave.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveGroup.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveStatistics.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveStatistics.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/SlaveStatistics.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/StateLog.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Statistics.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Statistics.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Statistics.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -27,5 +27,7 @@
   public partial class Task : LightweightTask {
 
-    public Task() { }
+    public Task() {
+      Priority = 1;
+    }
 
     protected Task(Task original, Cloner cloner)
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/TaskData.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserPriority.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserStatistics.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserStatistics.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/ServiceClients/UserStatistics.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.Designer.cs	(revision 11202)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.18034
+//     Runtime Version:4.0.30319.18047
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -26,5 +26,5 @@
         [global::System.Configuration.ApplicationScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("16")]
+        [global::System.Configuration.DefaultSettingValueAttribute("2")]
         public int MaxParallelUploads {
             get {
@@ -93,5 +93,5 @@
         [global::System.Configuration.ApplicationScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("5")]
+        [global::System.Configuration.DefaultSettingValueAttribute("3")]
         public int MaxEndpointRetries {
             get {
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Settings.settings	(revision 11202)
@@ -4,5 +4,5 @@
   <Settings>
     <Setting Name="MaxParallelUploads" Type="System.Int32" Scope="Application">
-      <Value Profile="(Default)">16</Value>
+      <Value Profile="(Default)">2</Value>
     </Setting>
     <Setting Name="HLBinaryName" Type="System.String" Scope="Application">
@@ -29,5 +29,5 @@
     </Setting>
     <Setting Name="MaxEndpointRetries" Type="System.Int32" Scope="Application">
-      <Value Profile="(Default)">5</Value>
+      <Value Profile="(Default)">3</Value>
     </Setting>
   </Settings>
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogList.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogList.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogList.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/StateLogListList.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Threading;
-using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Common;
 
@@ -79,8 +78,8 @@
 
     public TaskDownloader(IEnumerable<Guid> jobIds) {
-      this.taskIds = jobIds;
-      this.taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
-      this.taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
-      this.results = new Dictionary<Guid, HiveTask>();
+      taskIds = jobIds;
+      taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
+      taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      results = new Dictionary<Guid, HiveTask>();
     }
 
@@ -88,16 +87,11 @@
       foreach (Guid taskId in taskIds) {
         taskDownloader.DownloadTaskDataAndTask(taskId,
-          (localJob, itemJob) => {
-            if (localJob != null && itemJob != null) {
-              HiveTask hiveTask;
-              if (itemJob is OptimizerTask) {
-                hiveTask = new OptimizerHiveTask((OptimizerTask)itemJob);
-              } else {
-                hiveTask = new HiveTask(itemJob, true);
-              }
-              hiveTask.Task = localJob;
+          (localTask, itemTask) => {
+            if (localTask != null && itemTask != null) {
+              HiveTask hiveTask = itemTask.CreateHiveTask();
+              hiveTask.Task = localTask;
               try {
                 resultsLock.EnterWriteLock();
-                this.results.Add(localJob.Id, hiveTask);
+                results.Add(localTask.Id, hiveTask);
               }
               finally { resultsLock.ExitWriteLock(); }
@@ -113,6 +107,6 @@
     public event EventHandler<EventArgs<Exception>> ExceptionOccured;
     private void OnExceptionOccured(Exception exception) {
-      this.exceptionOccured = true;
-      this.currentException = exception;
+      exceptionOccured = true;
+      currentException = exception;
       var handler = ExceptionOccured;
       if (handler != null) handler(this, new EventArgs<Exception>(exception));
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -29,4 +29,9 @@
   [StorableClass]
   public class EngineTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      //only used when deserializing, so no problem with parentscope
+      return new EngineHiveTask(this, null);
+    }
+
     [Storable]
     protected IOperation initialOperation;
@@ -50,9 +55,10 @@
 
     #region constructors and cloning
-    public EngineTask() { }
     public EngineTask(IOperation initialOperation, IEngine engine) {
       this.initialOperation = initialOperation;
       this.Item = engine;
     }
+
+    public EngineTask(IEngine engine) : base(engine) { }
 
     [StorableConstructor]
@@ -144,5 +150,5 @@
 
     public override string Name {
-      get { return Item != null ? Item.ToString() : null; }
+      get { return Item != null ? Item.ToString() : "Engine Task"; }
       set { throw new NotSupportedException(); }
     }
@@ -153,5 +159,5 @@
 
     public override string ItemName {
-      get { return "EngineTask"; }
+      get { return "Engine Task"; }
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -22,8 +22,10 @@
 using System;
 using System.Drawing;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Hive;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Clients.Hive {
@@ -31,6 +33,11 @@
   [StorableClass]
   public abstract class ItemTask : NamedItem, ITask {
+    public virtual HiveTask CreateHiveTask() {
+      return new HiveTask(this, true);
+    }
+
     public virtual bool IsParallelizable {
       get { return true; }
+      set { }
     }
 
@@ -71,4 +78,7 @@
       this.Item = cloner.Clone(original.Item);
     }
+    public ItemTask(IItem item) {
+      Item = item;
+    }
 
     [StorableHook(HookType.AfterDeserialization)]
@@ -211,4 +221,27 @@
       return Name;
     }
+
+    #region Helpers
+    public static bool IsTypeSupported(Type itemType) {
+      var supportedHiveTaskTypes = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+          .Select(t => t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)).PropertyType);
+      return supportedHiveTaskTypes.Any(x => x.IsAssignableFrom(itemType));
+    }
+
+    public static Type GetHiveTaskType(Type itemType) {
+      if (!IsTypeSupported(itemType)) throw new Exception("Item " + itemType + " is not supported for Hive.");
+
+      var typeHiveTaskMap = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+          .Select(t => new Tuple<Type, Type>(t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)).PropertyType, t));
+
+      return typeHiveTaskMap.Single(x => x.Item1.IsAssignableFrom(itemType)).Item2;
+    }
+
+    public static ItemTask GetItemTaskForItem(IItem item) {
+      Type itemType = item.GetType();
+      Type hiveTaskType = GetHiveTaskType(itemType);
+      return Activator.CreateInstance(hiveTaskType, new object[] { item }) as ItemTask;
+    }
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -30,4 +30,8 @@
   [StorableClass]
   public class OptimizerTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      return new OptimizerHiveTask(this);
+    }
+
     public override bool IsParallelizable {
       get { return this.Item is Experiment || this.Item is BatchRun; }
@@ -46,13 +50,9 @@
     }
 
-    public OptimizerTask() : base() { }
     public OptimizerTask(IOptimizer optimizer)
-      : this() {
-      this.Item = optimizer;
-
-      if (optimizer is Experiment) {
+      : base(optimizer) {
+
+      if (optimizer is Experiment || optimizer is BatchRun) {
         this.ComputeInParallel = true;
-      } else if (optimizer is BatchRun) {
-        this.ComputeInParallel = false;
       } else {
         this.ComputeInParallel = false;
@@ -210,5 +210,5 @@
       get {
         if (Item == null)
-          return string.Empty;
+          return "Optimizer Task";
         else
           return Item.Name;
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTree.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/TreeView/IItemTreeAction.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PersistenceUtil.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs	(revision 9646)
+++ branches/HiveStatistics/sources/HeuristicLab.Clients.Hive/3.3/Util/PluginUtil.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
